# Audit Enricher

ESS’ Audit Enricher populates various Pod related audit messages with the associated Pod information.

<pre class="language-json"><code class="lang-json">
"instrument" : [
   // ...
<strong>   {
</strong><strong>      "hasDataSubject" : {
</strong><strong>         "id" : "&#x3C;Pod data subject's WebID>",
</strong><strong>         "type" : [
</strong><strong>            "https://w3id.org/dpv#DataSubject"
</strong><strong>         ],
</strong><strong>      },
</strong><strong>      "hasStorage" : "&#x3C;PodURL>",
</strong><strong>      "type" : [
</strong><strong>         "http://www.w3.org/2004/02/skos/core#Concept"
</strong><strong>      ]
</strong><strong>   }
</strong>   // ...
],
</code></pre>

The Pod data subject refers to the agent who created the Pod.

### Use of Cache

After the Audit Enricher fetches the Pod information for a message, the Pod information is cached. For subsequent messages affecting the Pod, the Enricher uses the cache.

### Migration Service

The Migration Service runs as a Kubernetes Cron Job. It runs in the background and will not take ESS offline to complete the migration.

While the migration is running, an Operator can observe using logs and metrics and will be able to see when it has been completed.

Once the migration is complete, the Migration Cron Job will idle, and the operator can safely stop the job from running.

To stop the Migration Cron Job from running once the migration is complete:

1. Add the following patch to your **`kustomization.yaml`** file:

   <pre class="language-yaml"><code class="lang-yaml">
    # kustomization.yaml in your ESS installation directory
    # ...  Preceding content omitted for brevity
    # ...
    patches:
   <strong>   - target:
   </strong><strong>       kind: CronJob
   </strong><strong>       name: ess-storage-migrate-system-resource
   </strong><strong>     patch: |-
   </strong><strong>       apiVersion: batch/v1
   </strong><strong>       kind: CronJob
   </strong><strong>       metadata:
   </strong><strong>         name: ess-storage-migrate-system-resource
   </strong><strong>       spec:
   </strong><strong>         suspend: true
   </strong><strong> 
   </strong> 
   </code></pre>
2. Continue with the rest of the [Applying Your Customizations](/ess/2.5/installation/customize-configurations.md#applying-your-customizations) procedure.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.inrupt.com/ess/2.5/services/service-auditing/service-audit-enricher.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
